=== modified file 'src/com/goldencode/p2j/ui/TreeWidgetBase.java' (properties changed: +x to -x)
--- src/com/goldencode/p2j/ui/TreeWidgetBase.java	2021-06-01 18:55:22 +0000
+++ src/com/goldencode/p2j/ui/TreeWidgetBase.java	2021-06-17 18:05:43 +0000
@@ -2747,13 +2741,13 @@
     * 
     * @return   The node id if the provided value represents a valid node, otherwise Integer.MIN_VALUE.
     */
-   private int getNodeIdFrom(handle value)
+   private static int getNodeIdFrom(final handle value)
    {
       int nodeId = Integer.MIN_VALUE;
       
       if (value != null && !value.isUnknown())
       {
-         nodeId = ((TreeNodeResource<N>) value.getResource()).getNodeId().intValue();
+         nodeId = ((TreeNodeResource) value.getResource()).getNodeId().intValue();
       }
       
       return nodeId;
@@ -2767,9 +2761,9 @@
     * @param   collapsedNode
     *          The node on which the collapse operation was done.
     */
-   private void doSelectAfterCollapse(TreeNodeResource<N> collapsedNode)
+   private void doSelectAfterCollapse( TreeNodeFace collapsedNode)
    {
-      TreeNodeResource<N> selectedAncestor = ((TreeNodeResource<N>) getSelectedNode().getResource());
+       TreeNodeFace selectedAncestor = ((TreeNodeResource) getSelectedNode().getResource());
       
       if (!validSelection() || collapsedNode == selectedAncestor)
       {
@@ -2780,17 +2774,27 @@
              selectedAncestor != collapsedNode && 
              selectedAncestor != rootNode)
       {
-         selectedAncestor = selectedAncestor._getParent();
+         selectedAncestor = ((TreeNodeResource)selectedAncestor)._getParent();
       } 
       
       
       if (selectedAncestor == collapsedNode)
       {
-         _setSelectedNode(collapsedNode._getNodeId());
+         _setSelectedNode(((TreeNodeResource)collapsedNode)._getNodeId());
       }
    }
    
    /**
+    * Returns the ID of the top visible node or -1 if this tree is empty.
+    *
+    * @return see above.
+    */
+   private final int _getTopVisibleNodeId()
+   {
+      return getAttr("topNode", () -> config.topNode, true);
+   }
+
+   /**
     * Check if the current selected node is valid: is known and attached to this tree.
     * 
     * @return   {@true} if the selected node is known and belongs to this tree.

=== modified file 'src/com/goldencode/p2j/ui/client/gui/TreeBodyGuiImpl.java'
--- src/com/goldencode/p2j/ui/client/gui/TreeBodyGuiImpl.java	2021-06-10 10:44:35 +0000
+++ src/com/goldencode/p2j/ui/client/gui/TreeBodyGuiImpl.java	2021-06-18 19:29:15 +0000
@@ -120,6 +120,7 @@
 import com.goldencode.p2j.ui.client.gui.TreeGuiImpl.*;
 import com.goldencode.p2j.ui.client.gui.driver.*;
 import com.goldencode.p2j.ui.client.gui.theme.*;
+import com.goldencode.p2j.ui.client.model.*;
 import com.goldencode.p2j.ui.client.widget.*;
 
 // this usage of AWT events is intentional, they are being used separately from the
@@ -139,18 +140,12 @@
  * @param <N> 
  *        node type
  */
-public abstract class TreeBodyGuiImpl<
-      C extends TreeConfig<N>,
-      T extends TreeGuiImpl<C, ? extends TreeBodyGuiImpl<C,T,N>, N>,
-      N extends TreeNodeEntry>
+public abstract class TreeBodyGuiImpl
 extends AbstractWidget<GuiOutputManager>
 implements ScrollableWidget<GuiOutputManager>,
-           ScrollPublisher,
-           TreeViewDelegate
+           TreeViewDelegate,
+           I2DScrollable
 {
-   /** Widget id */
-   private final WidgetId id;
-
    /** Screen driver */
    protected GuiDriver<?,?> gd;
 
@@ -170,22 +165,22 @@
    protected ColorRgb disabledFore;
 
    /** The owning tree view */
-   protected T tree;
+   protected TreeGuiImpl tree;
 
    /** The theme used for drawing */
    protected ClassicTheme theme;
 
-   /** Calculated widget width */
-   private double width;
-
-   /** Calculated widget height */
-   private double height;
+   /**
+    * The widget config. The application sets the {@link BaseConfig#widthChars}
+    * and {@link BaseConfig#heightChars} while laying out.
+    */
+   protected BaseConfig config = new BaseConfig();
 
    /** List of scroll listeners */
    private List<ScrollListener> scrollListeners = new LinkedList<>();
 
    /** The node with active tooltip */
-   private TreeGuiImpl.TreeNode<N> tooltipNode;
+   private TreeNode tooltipNode;
 
    /**
     * Constructor.
@@ -193,13 +188,16 @@
     * @param   tree
     *          The owning tree view.
     */
-   public TreeBodyGuiImpl(T tree)
+   public TreeBodyGuiImpl(final TreeGuiImpl tree)
    {
-      id = WidgetId.nextID();
+      config.id = WidgetId.nextID();
       
       this.tree = tree;
       
-      TreeConfig<N> c = tree.config();
+      tree.hModel.addListener(this);
+      tree.vModel.addListener(this);
+
+      final TreeConfig c = tree.config();
 
       // initialize screen driver
       gd = (GuiDriver<?,?>) OutputManager.getDriver();
@@ -211,7 +209,7 @@
       updateColors(c);
       disabledFore  = gd.getSysColor(SysColor.COLOR_3DSHADOW);
 
-      int bgColor = isThreeD() && !c.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
+      final int bgColor = isThreeD() && !c.enabled ? SysColor.COLOR_3DFACE : SysColor.COLOR_WINDOW;
       gc = new GuiColorResolver(gd, c, bgColor, SysColor.COLOR_BTNTEXT);
 
       // at this point classic theme is expected
@@ -224,7 +222,7 @@
     * @param   c
     *          Treeview config.
     */
-   public void updateColors(TreeConfig<N> c)
+   public void updateColors(TreeConfig c)
    {
       ColorRgb colorRgb = new ColorRgb();
       colorRgb.setRgb(c.getSelectedNodeBg());
@@ -245,7 +243,7 @@
    @Override
    public WidgetId getId()
    {
-      return id;
+      return config.id;
    }
 
    /**
@@ -282,14 +280,14 @@
       }
 
       final int key = event.keyCode();
-      final TreeGuiImpl.TreeNode<N> currentNode = tree.currentNode;
+      final TreeNode currentNode = tree.currentNode;
       final TreeNodeEntry nodeValue = currentNode == null ? null : currentNode.value;
       switch (key)
       {
          case Key.VK_HOME:
          {
             // Navigate to the first visible node
-            final TreeNode<N> firstVisible = firstVisible();
+            final TreeNode firstVisible = firstVisible();
             if (firstVisible != null)
             {
                tree.setCurrentNode(firstVisible);
@@ -300,10 +298,10 @@
          case Key.VK_END:
          {
             // Navigate to the last visible node
-            final TreeNode<N> firstVisible = firstVisible();
+            final TreeNode firstVisible = firstVisible();
             if (firstVisible != null)
             {
-               final TreeGuiImpl.TreeNode<N> lastVisible = getNextVisibleNode(firstVisible, false,
+               final TreeNode lastVisible = getNextVisibleNode(firstVisible, false,
                         0, true);
                tree.setCurrentNode(lastVisible, true, true);
             }
@@ -399,7 +397,7 @@
       deactivateTooltip();
       
       final NativePoint n = translate(e);
-      final TreeGuiImpl.TreeNode<N> node = isNodeContentAtLocation(n);
+      final TreeNode node = isNodeContentAtLocation(n);
       if (node != null)
       {
          if (node != tree.getCurrentNode())
@@ -417,7 +415,7 @@
          return;
       }
       
-      final TreeGuiImpl.TreeNode<N> toggleNode = isExpandIconAtLocation(n);
+      final TreeNode toggleNode = isExpandIconAtLocation(n);
       if (toggleNode != null)
       {
          tree.toggleNodeExpansion(toggleNode);
@@ -433,7 +431,7 @@
    @Override
    public void mouseClicked(final MouseEvent e)
    {
-      final TreeGuiImpl.TreeNode<N> node = isNodeContentAtLocation(translate(e));
+      final TreeNode node = isNodeContentAtLocation(translate(e));
 
       if (node != null)
       {
@@ -441,7 +439,7 @@
       }
       
       final int clickCount = e.getClickCount();
-      final C config = tree.config();
+      final TreeConfig config = tree.config();
       if (node != null
           && ((clickCount == 1 && config.expandOnSingleClick) || 
               (clickCount == 2 && config.expandOnDoubleClick)))
@@ -480,10 +478,18 @@
     *          The mouse event.
     */
    @Override
-   public void mouseWheelMoved(MouseWheelEvent e)
+   public void mouseWheelMoved(final MouseWheelEvent e)
    {
       tree.getTreeEditor().deactivateEditor();
-      tree.scrollpane.mouseWheelMoved(e);
+      final int step = e.getWheelRotation();
+      if (e.isControlDown())
+      {
+         tree.hModel.increment(step);
+      }
+      else
+      {
+         tree.vModel.increment(step);
+      }
    }
 
    /**
@@ -493,10 +499,10 @@
     *          The mouse event.
     */
    @Override
-   public void mouseMoved(MouseEvent e)
+   public void mouseMoved(final MouseEvent e)
    {
       NativePoint n = translate(e);
-      TreeGuiImpl.TreeNode<N> node = isNodeContentAtLocation(n);
+      final TreeNode node = isNodeContentAtLocation(n);
       if (node != tooltipNode && tooltipNode != null)
       {
          deactivateTooltip();
@@ -504,7 +510,16 @@
 
       if (node != null && node != tooltipNode)
       {
-         activateTooltip(node, new NativePoint(e.getX(), e.getY()));
+         // This holds for any visible node:
+         assert node.value != null;
+         
+         final String tooltip = node.value.tooltip;
+         if (tooltip != null && !tooltip.isEmpty())
+         {
+            final ToolTip tt = ToolTip.getInstance();
+            tt.activate(this, tooltip, -1, new NativePoint(e.getX(), e.getY()));
+            tooltipNode = node;
+         }
       }
    }
 
@@ -564,7 +579,7 @@
    @Override
    public double width()
    {
-      return width;
+      return config.widthChars;
    }
 
    /**
@@ -575,7 +590,7 @@
    @Override
    public double height()
    {
-      return height;
+      return config.heightChars;
    }
 
    /**
@@ -590,18 +605,6 @@
    }
 
    /**
-    * Add scroll listener.
-    *
-    * @param   listener
-    *          Listener to add.
-    */
-   @Override
-   public void addScrollListener(ScrollListener listener)
-   {
-      scrollListeners.add(listener);
-   }
-
-   /**
     * Returns the scroll dimension of this widget. The scroll dimension is
     * the full size of the widget's content, it may be bigger than widget's
     * visible size.
@@ -662,27 +665,29 @@
     *          New Y scroll position.
     */
    @Override
-   public void scroll(Integer newXPosition, Integer newYPosition)
+   public void scroll(final Integer newXPosition, final Integer newYPosition)
    {
-      if (newXPosition == null)
-      {
-         newXPosition = physicalLocation().x;
-      }
-      else
-      {
-         newXPosition = -newXPosition;
-      }
-
-      if (newYPosition == null)
-      {
-         newYPosition = physicalLocation().y;
-      }
-      else
-      {
-         newYPosition = -newYPosition;
-      }
-
-      setPhysicalLocation(newXPosition, newYPosition);
+      Integer x = newXPosition;
+      Integer y = newYPosition;
+      if (x == null)
+      {
+         x = physicalLocation().x;
+      }
+      else
+      {
+         x = -x;
+      }
+
+      if (y == null)
+      {
+         y = physicalLocation().y;
+      }
+      else
+      {
+         y = -y;
+      }
+
+      setPhysicalLocation(x, y);
       
       int oldTopNode = tree.config().topNode;
       int newTopNode = getTopNode().value.nodeId;
@@ -724,8 +729,9 @@
    public Integer hitTest(int x, int y)
    {
       NativePoint point = getLocationRelativeToBody(x, y);
+      final NativePoint point1 = point;
       
-      TreeGuiImpl.TreeNode<N> node = hitTest(point);
+      TreeNode node = isNodeContentAtLocation(point1);
       
       return node != null && node.value != null ? node.value.nodeId : null;
    }
@@ -744,42 +750,48 @@
    public abstract NativePoint getLocationRelativeToBody(int x, int y);
    
    /**
-    * Calculates the widget size.
+    * Calculates the widget size:
+    * set config.widthChars, config.heightChars, tree.config().topNode
+    * 
+    * Called from {@link TreeGuiImpl#buildTreeModel()}, and {@link TreeGuiImpl#toggleNodeExpansion(TreeNode)}
     */
-   public void calcSize()
+   public final void calcSize()
    {
-      ScrollPane<?> sp = parent(ScrollPane.class);
-      Insets spInsets = sp.insets();
-      Dimension spDim = sp.dimension();
-      double spWidth = Coordinate.scale(spDim.width - spInsets.widthDelta());
-      double spHeight = Coordinate.scale(spDim.height - spInsets.heightDelta());
+      final Dimension spDim = parent().dimension();
+      final double spWidth = spDim.width;
+      final double spHeight = spDim.height;
 
-      TreeGuiImpl.TreeNode<N>  rootNode = tree.rootNode;
+      final TreeNode rootNode = tree.rootNode;
       if (rootNode == null || rootNode.nodes == null)
       {
-         width = spWidth;
-         height = spHeight;
+         config.widthChars = spWidth;
+         config.heightChars = spHeight;
          return;
       }
 
       // count visible nodes count
-      int nodeCount = 0;
-      TreeGuiImpl.NodesIterator<N> it = new TreeGuiImpl.NodesIterator<>(rootNode, true);
-      while(it.hasNext())
-      {
-         nodeCount++;
-         it.next();
-      }
-
-      int scrollBarWidth = ThemeManager.getCurrentTheme().getScrollBarButtonWidth();
-      int nativeWidth = calcMaxNodesWidth(rootNode.nodes, 0, 0) + 2 * TREEVIEW_INNER_PADDING + scrollBarWidth;
-      int nativeHeight = getNodeHeight() * nodeCount;
-
-      CoordinatesConversion cc = screen().coordinates();
-      width = Math.max(cc.widthFromNative(nativeWidth), spWidth);
-      height = Math.max(cc.heightFromNative(nativeHeight), spHeight);
-      final N value = getTopNode().value;
-      tree.config().topNode = value != null ? value.nodeId : 0;
+      final int nodeCount = getVisibleNodeCount();
+
+      final int scrollBarWidth = ThemeManager.getCurrentTheme().getScrollBarButtonWidth();
+      final int nativeWidth = calcMaxNodesWidth(rootNode.nodes, 0, 0) + 2 * TREEVIEW_INNER_PADDING
+               + scrollBarWidth;
+      final int nativeHeight = getNodeHeight() * nodeCount;
+
+      final CoordinatesConversion cc = screen().coordinates();
+      config.widthChars = Math.max(cc.widthFromNative(nativeWidth), spWidth);
+      config.heightChars = Math.max(cc.heightFromNative(nativeHeight), spHeight);
+      
+      final TreeNode topNode = getTopNode();      
+      final TreeNodeEntry value;
+      if (topNode != null)
+      {
+         value = topNode.value;
+      }
+      else
+      {
+         value = null;
+      }
+      tree.config().topNode = value != null ? value.nodeId : -1;
    }
    
    /**
@@ -790,7 +802,7 @@
     */
    void scrollToTop(int nodeId)
    {
-      TreeGuiImpl.TreeNode<N>  node = tree.findNode(nodeId);
+      TreeNode node = tree.findNode(nodeId);
       if (node != null)
       {
          ensureVisible(node, true, false);
@@ -832,21 +844,21 @@
     *
     * @return  array of size 2, at index 0 the found node, at index 1 the total node count.
     */
-   private TreeGuiImpl.TreeNode<N>  getNextVisibleNode(TreeGuiImpl.TreeNode<N>  relativeTo,
-                                       boolean forward,
-                                       int skip,
-                                       boolean rollover)
+   private TreeNode getNextVisibleNode(TreeNode relativeTo,
+                                       final boolean forward,
+                                       final int skip,
+                                       final boolean rollover)
    {
-      TreeGuiImpl.NodesIterator<N> it = new TreeGuiImpl.NodesIterator<>(tree.rootNode, true, !forward);
-      TreeGuiImpl.TreeNode<N>  result = null;
+      final NodesIterator it = new NodesIterator(tree.rootNode, true, !forward);
+      TreeNode  result = null;
       int count = 0;
       boolean relativeFound = relativeTo == null && forward;
-      TreeGuiImpl.TreeNode<N>  first = null;
-      TreeGuiImpl.TreeNode<N>  last = null;
+      TreeNode  first = null;
+      TreeNode  last = null;
 
       while (it.hasNext())
       {
-         TreeGuiImpl.TreeNode<N>  node = it.next();
+         final TreeNode node = it.next();
 
          if (first == null)
          {
@@ -885,9 +897,9 @@
     * 
     * @return the first visible node or {@code null} if tree has no visible nodes.
     */
-   private final TreeGuiImpl.TreeNode<N> firstVisible()
+   private final TreeNode firstVisible()
    {
-      final TreeGuiImpl.NodesIterator<N> it = new TreeGuiImpl.NodesIterator<>(tree.rootNode, true, false);
+      final NodesIterator it = new NodesIterator(tree.rootNode, true, false);
       return it.hasNext() ? it.next() : null;
    }
    
@@ -918,22 +930,22 @@
     *
     * @return  the found node or {@code null}.
     */
-   protected TreeGuiImpl.TreeNode<N>  isNodeContentAtLocation(NativePoint loc)
+   protected TreeNode isNodeContentAtLocation(final NativePoint loc)
    {
       if (loc.y < 0)
       {
          return null;
       }
 
-      int nodeHeight = getNodeHeight();
-      int row = loc.y / nodeHeight;
-      TreeGuiImpl.TreeNode<N>  node = getVisibleNode(row);
+      final int nodeHeight = getNodeHeight();
+      final int row = loc.y / nodeHeight;
+      final TreeNode  node = getVisibleNode(row);
       if (node == null)
       {
          return null;
       }
 
-      int level = tree.getNodeLevel(node);
+      int level = node.getLevel();
       
       int nodeTextOffset = TREEVIEW_INNER_PADDING + theme.getTreeViewNodeHorizontalOffset(level);
       
@@ -942,7 +954,7 @@
          return null;
       }
 
-      NativeRectangle labelBounds = tree.getNodeLabelBounds(node);
+      final NativeRectangle labelBounds = tree.getNodeLabelBounds(node);
       
       if (loc.x > labelBounds.right())
       {
@@ -960,16 +972,16 @@
     *
     * @return  the found node or {@code null}.
     */
-   private TreeGuiImpl.TreeNode<N>  isExpandIconAtLocation(NativePoint loc)
+   private TreeNode isExpandIconAtLocation(final NativePoint loc)
    {
       if (!tree.config().showExpandIcon)
       {
          return null;
       }
 
-      int nodeHeight = getNodeHeight();
-      int row = loc.y / nodeHeight;
-      TreeGuiImpl.TreeNode<N>  node = getVisibleNode(row);
+      final int nodeHeight = getNodeHeight();
+      final int row = loc.y / nodeHeight;
+      final TreeNode node = getVisibleNode(row);
       if (node == null)
       {
          return null;
@@ -980,8 +992,8 @@
          return null;
       }
 
-      int level = tree.getNodeLevel(node);
-      int iconX = TREEVIEW_INNER_PADDING +
+      final int level = node.getLevel();
+      final int iconX = TREEVIEW_INNER_PADDING +
       TREEVIEW_EXPAND_ICON_OFFSET + theme.getTreeViewNodeHorizontalOffset(level - 1);
       if (loc.x < iconX)
       {
@@ -1005,9 +1017,9 @@
     *
     * @return  the found node or {@code null}.
     */
-   protected TreeGuiImpl.TreeNode<N>  getVisibleNode(int rowIndex)
+   protected TreeNode getVisibleNode(final int rowIndex)
    {
-      TreeGuiImpl.NodesIterator<N> it = new TreeGuiImpl.NodesIterator<>(tree.rootNode);
+      final NodesIterator it = new NodesIterator(tree.rootNode);
       int i = 0;
       while (it.hasNext())
       {
@@ -1033,6 +1045,7 @@
     * 
     * @return see above
     */
+   @SuppressWarnings("static-method")
    protected boolean isVertThrough()
    {
       return false;
@@ -1050,22 +1063,22 @@
     *
     * @return  the calculated width.
     */
-   protected abstract int calcMaxNodesWidth(List<TreeGuiImpl.TreeNode<N> > nodes,
+   protected abstract int calcMaxNodesWidth(List<TreeNode > nodes,
                                             int maxWidth,
                                             int level);
 
    /**
     * Get the node instance which is on the top of the viewport.
     * 
-    * @return  The node on top of the viewport or the root node if no node in viewport.
+    * @return  The node on top of the viewport or the {@code null} if no node in viewport.
     * 
     */
-   private TreeNode<N> getTopNode()
+   private final TreeNode getTopNode()
    {
-      int idx = getTopNodeIndex();
-      TreeGuiImpl.NodesIterator<N> it = new TreeGuiImpl.NodesIterator<>(tree.rootNode);
+      final NodesIterator it = new NodesIterator(tree.rootNode);
       
-      while (it.hasNext() && idx > 0)
+      int idx = tree.vModel.getPosition();      
+      while (idx > 0 && it.hasNext())
       {
          it.next();
          idx--;
@@ -1073,7 +1086,7 @@
       
       if (!it.hasNext())
       {
-         return tree.rootNode;
+         return null;
       }
       
       return it.next();
@@ -1086,8 +1099,8 @@
     */
    private int getTopNodeIndex()
    {
-      int rowHeight = getNodeHeight();
-      NativePoint loc = physicalLocation();
+      final int rowHeight = getNodeHeight();
+      final NativePoint loc = physicalLocation();
       return Math.abs((int) Math.ceil((double) loc.y / rowHeight));
    }
 
@@ -1102,7 +1115,7 @@
     * @param   forceBottom
     *          Whether the node should be placed at the bottom of the view.
     */
-   void ensureVisible(TreeGuiImpl.TreeNode<N>  node, boolean forceTop, boolean forceBottom)
+   void ensureVisible(TreeNode  node, boolean forceTop, boolean forceBottom)
    {
       Integer scrollX = null;
       
@@ -1172,12 +1185,13 @@
       setMouseCursor(CursorType.DEFAULT);
 
       NativePoint point = translate(e);
-      TreeGuiImpl.TreeNode<N>  target = hitTest(point);
+      final NativePoint point1 = point;
+      TreeNode  target = isNodeContentAtLocation(point1);
       Object data = OleDragDrop.getData(CF_TEXT);
       
-      if (target != null && data instanceof TreeGuiImpl.TreeNode)
+      if (target != null && data instanceof TreeNode)
       {
-         TreeGuiImpl.TreeNode<N>  source = (TreeGuiImpl.TreeNode<N> ) data;
+         TreeNode  source = (TreeNode ) data;
 
          if (target.value.equals(source.value))
          {
@@ -1226,7 +1240,8 @@
       setMouseCursor(CursorType.TEXT);
 
       NativePoint point = translate(e);
-      TreeGuiImpl.TreeNode<N>  source = hitTest(point);
+      final NativePoint point1 = point;
+      TreeNode  source = isNodeContentAtLocation(point1);
       if (source != null)
       {
          if (source.parent == null)
@@ -1261,7 +1276,8 @@
    protected void oleDragging(MouseEvent e)
    {
       NativePoint point = translate(e);
-      TreeGuiImpl.TreeNode<N> overNode = hitTest(point);
+      final NativePoint point1 = point;
+      TreeNode overNode = isNodeContentAtLocation(point1);
       if (overNode != null)
       {
          if (overNode.parent == null)
@@ -1286,22 +1302,24 @@
     * @param   newYPosition
     *          New Y position.
     */
-   private void requestScroll(Integer newXPosition, Integer newYPosition)
+   private void requestScroll(final Integer newXPosition, final Integer newYPosition)
    {
+      Integer x = newXPosition;
+      Integer y = newYPosition;
       NativeDimension max = getScrollDimension();
-      if (newXPosition != null && newXPosition > max.width)
+      if (x != null && x > max.width)
       {
-         newXPosition = max.width;
+         x = max.width;
       }
 
-      if (newYPosition != null && newYPosition > max.height)
+      if (y != null && y > max.height)
       {
-         newYPosition = max.height;
+         y = max.height;
       }
 
       for (ScrollListener scrollListener : scrollListeners)
       {
-         scrollListener.handleScrollEvent(new ScrollEvent(this, newXPosition, newYPosition));
+         scrollListener.handleScrollEvent(new ScrollEvent(this, x, y));
       }
    }
 
@@ -1311,7 +1329,7 @@
     * @param   node
     *          The target node.
     */
-   private void triggerDefaultAction(TreeGuiImpl.TreeNode<N>  node)
+   private void triggerDefaultAction(TreeNode  node)
    {
       tree.config().triggerNode = node.value.nodeId;
       EventManager.postEvent(new KeyInput(tree, EventType.KEY_PRESSED, Keyboard.SE_DEFAULT_ACTION));
@@ -1328,7 +1346,7 @@
     */
    private void fireChangeTopVisibleNode(int prevNodeId, int scrollNodeCount)
    {
-      C config = tree.config();
+      final TreeConfig config = tree.config();
       config.triggerNode = prevNodeId;
       config.scrollNodeCount = scrollNodeCount;
       
@@ -1343,7 +1361,7 @@
     * 
     * @return   True if the trigger code returns NO-APPLY, otherwise false.
     */
-   private boolean fireNodeClickEvent(TreeGuiImpl.TreeNode<N>  node)
+   private boolean fireNodeClickEvent(final TreeNode node)
    {
       tree.config().triggerNode = node.value.nodeId;
       
@@ -1355,24 +1373,6 @@
    }
 
    /**
-    * Activates node tooltip.
-    *
-    * @param   node
-    *          The target node.
-    * @param   point
-    *          The location where to activate the tooltip.
-    */
-   private void activateTooltip(TreeGuiImpl.TreeNode<N>  node, NativePoint point)
-   {
-      if (node != null && node.value.tooltip != null && !node.value.tooltip.isEmpty())
-      {
-         ToolTip tt = ToolTip.getInstance();
-         tt.activate(this, node.value.tooltip, -1, point);
-         tooltipNode = node;
-      }
-   }
-
-   /**
     * Deactivates an active tooltip.
     */
    private void deactivateTooltip()
@@ -1388,27 +1388,93 @@
    }
 
    /**
-    * Provides node information, given a point. 
-    * 
-    * @param   point 
-    *          given point
-    * 
-    * @return  Node under the mouse cursor or <code>null</code> if not hit
-    */
-   private TreeGuiImpl.TreeNode<N>  hitTest(NativePoint point)
-   {
-      return isNodeContentAtLocation(point);
-   }
-
-   /**
     * Set mouse cursor.
     * 
     * @param   cursor
     *          Mouse cursor
     */
-   private void setMouseCursor(CursorType cursor)
+   private void setMouseCursor(final CursorType cursor)
    {
-      MousePtrWrapper mousePointerWrapper = MousePtrWrapper.createPreDefinedInstance(cursor);
+      final MousePtrWrapper mousePointerWrapper = MousePtrWrapper.createPreDefinedInstance(cursor);
       gd.setCursor(mousePointerWrapper);
    }
+
+   @Override
+   public BaseConfig config()
+   {
+      return config;
+   }
+   
+   private final int getVisibleNodeCount()
+   {
+      final NodesIterator it = new NodesIterator(tree.rootNode);
+      int count = 0;
+      while (it.hasNext())
+      {
+         it.next();
+         count++;
+      }
+      return count;
+   }
+
+   /**
+    * Update the vertical scrolling model based on this object geometry and contents.
+    * 
+    * @return {@code true} if model was changed as the result of the call.
+    */
+   @Override
+   public boolean updateVScrollModel()
+   {
+      final int widgetHeightPixels = screen().coordinates().heightToNative(height());
+      final int rowHeight = getNodeHeight();
+      final int modelPage = widgetHeightPixels / rowHeight;
+      final int modelWidth = getVisibleNodeCount();
+
+      final ScrollModel vModel = tree.vModel;
+      int newPosition = vModel.getPosition();
+
+      /**
+       * We need to assure the starting position is valid.
+       */
+      newPosition = Math.max(0, Math.min(newPosition, modelWidth - 1));
+
+      /**
+       * Count how many rows fully visible starting from current top
+       * row and below.
+       */
+      
+      // Rows starting from the top and below
+      final int rowsFromTop = modelWidth - newPosition;
+      // Rows clipped below the view
+      final int rowsClippedBelow = rowsFromTop - modelPage;
+      if (rowsClippedBelow >= 0)
+      {
+         // View is filled fully
+         return vModel.set(modelWidth, modelPage, newPosition);         
+      }
+
+      // Some rows are empty, try to "scroll up" to display as many rows as possible
+      newPosition = Math.max(0, newPosition + rowsClippedBelow);
+      return vModel.set(modelWidth, modelWidth - newPosition, newPosition);
+   }
+
+   /**
+    * This procedure is called by the model after it was changed.
+    * 
+    * @param model the model that was changed
+    */
+   @Override
+   public void modelChanged(Model model)
+   {
+      if (model == tree.hModel)
+      {
+         updateHScrollModel();
+      }
+      else
+      {
+         final TreeNodeEntry value = getTopNode().value;
+         tree.config().topNode = value != null ? value.nodeId : -1;
+      }
+      repaint();               
+   }
 }

